;
; BIOSi荞݁AfBXN֘Aj
;

	relaxed on


Disk60_Entry	equ	$8000

Disk_Load	equ	Disk60_Entry+3
Disk_Save	equ	Disk60_Entry+6
DISKBUF		equ	$8300

SCOREBUF	equ	$84f0
TBL_GETBYTE	equ	$852f
TBL_LOADEXPAND	equ	$8545
TBL_SETDRWFILE	equ	$8548
TBL_FILELOAD	equ	$854b
TBL_SECLOAD	equ	$854e
TBL_SECSAVE	equ	$8551

RETDRW		equ	$bff7

;
; 荞݊֘A
;
	org	$8400

INT_TABLE:
	dw	INTDT0		; 0x00
	dw	INTKEYIN	; 0x02iKEYINPUTj
	dw	INTDT0		; 0x04iRS-232Cj
	dw	INTTIMER	; 0x06iTIMERj
	dw	INTDT1		; 0x08iCMT READj
	dw	INTDT0		; 0x0A
	dw	INTDT0		; 0x0C
	dw	INTDT1		; 0x0EiL[́j
	dw	INTDT1		; 0x10iL[́j
	dw	INTDT0		; 0x12iCMT ERRORj
	dw	INTKEYIN	; 0x14iL[́j
	dw	INTGAMEKEY	; 0x16iQ[L[́j
	dw	INTDT0		; 0x18iTVRj
	dw	INTDT0		; 0x1AiTIME֘Aj
	dw	INTDT1		; 0x1CiTIME֘Aj
	dw	INTDT0		; 0x1E
	dw	INTDT0		; 0x20iVOICEj
	dw	INTDT0		; 0x22iVSYNCj

TIMERCNT:
	db	$00		; 0x8424F^C}JEgp
VSYNCBUF:
	db	$00		; 0x8425FVSYNCobt@
KEYCNT:
	db	$00		; 0x8426FI[gs[g̃LZpJE^
KEYDATA:
	db	$00		; 0x8427FL[̓obt@
GAMEDATA:
	db	$00		; 0x8428FQ[L[̓obt@
BGMON:
	db	$00		; 0x8429F^C}JEgp
TIMERB:
	db	$d0		; 0x842aF^C}JEgp
BGMINT:
	dw	$0000		; 0x842bF^C}JEgp

;
; L[͊荞
;
; ʏL[́AASCIIR[h
; GRAPH+L[̏ꍇ́AASCIIR[h
; t@NVL[̏ꍇ́A0xf0`0xf9
; STOPL[̏ꍇ́A0xfa
; CAPSL[̏ꍇ́A0xfb
; MODEL[̏ꍇ́A0xfd
;
INTKEYIN:
	push	af
	xor	a
	ld	(KEYCNT),a
	call	GETSUBCPU
	cp	$f0
	jr	nz,.next

	ld	a,(CSS)
	inc	a
	cp	$f6
	jr	c,.c0
	ld	a,$f0
.c0:
	ld	(CSS),a
	out	($c0),a		; CSS3-1=000
	xor	a

.next:
	ld	(KEYDATA),a
	pop	af
	ei
	ret

CSS:	db	$f0

;
; ^C}荞
;
INTTIMER:
	push	af
	push	hl

	ld	a,(TIMERCNT)
	inc	a
	and	$03
	ld	(TIMERCNT),a
	jr	nz,.next1

	ld	a,$06
	call	SETSUBCPU	; Q[L[Ăяo

.next1:
	ld	a,(KEYCNT)
	inc	a
	and	$ff
	ld	(KEYCNT),a
	jr	nz,.next2
	xor	a
	ld	(KEYDATA),a	; ^C}AL[obt@NA

.next2:
	pop	hl
	pop	af
	ei
	ret

;
; Q[L[荞
;
INTGAMEKEY:
	push	af
	push	bc

	call	GETSUBCPU

		;
		; TuCPŨQ[L[JOYSTICK̕тɕύX
		; SPC "0" E STOP SFT
		;  
		; "0" STOP SFT SPC E

	ld	b,a
	xor	a
	bit	2,b
	jr	z,.lp1
	or	$01
.lp1:	bit	3,b
	jr	z,.lp2
	or	$02
.lp2:	bit	5,b
	jr	z,.lp3
	or	$04
.lp3:	bit	4,b
	jr	z,.lp4
	or	$08
.lp4:	bit	7,b
	jr	z,.lp5
	or	$10
.lp5:	bit	0,b
	jr	z,.lp6
	or	$20
.lp6:	bit	1,b
	jr	z,.lp7
	or	$40
.lp7:
	ld	b,a

		;
		; WCXeBbN|[gɃANZX
		;
	ld	a,$0f
	out	($a0),a
	ld	a,$c0
	out	($a1),a
	ld	a,$0e
	out	($a0),a
	in	a,($a2)
	cpl
	and	$3f
		;
		; AregF"0" "0" TRG2 TRG1 E

	or	b
	ld	(GAMEDATA),a

	pop	bc
	pop	af
	ei
	ret


; _[N
;
	org	SCOREBUF
	db	$ff

;
; Wve[u
;
	org	TBL_GETBYTE
	jp	GET_BYTE

	org	TBL_LOADEXPAND
	jp	LOADEXPAND

	org	TBL_SETDRWFILE
	jp	SETDRWFILE

	org	TBL_FILELOAD
	jp	FILE_LOAD

	org	TBL_SECLOAD
	jp	SEC_LOAD

	org	TBL_SECSAVE
	jp	SEC_SAVE

;
; 荞ݏI[if[^PoCgM{Ȃj
;
INTDT1:
	push	af
	call	GETSUBCPU
	pop	af
;
; 荞ݏI[iȂj
;
INTDT0:
	ei
	ret


;
; TuCPUPoCgf[^M
;
; RETFAreg=Mf[^
;
GETSUBCPU:
	ld	a,$0c
	out	($93),a
.wait:
	in	a,($92)
	and	$20
	jr	z,.wait
	ld	a,$0d
	out	($93),a
	in	a,($90)
	ret

;
; TuCPUւPoCgf[^𑗐M
;
; Areg=Mf[^
;
SETSUBCPU:
	push	af
	ld	a,$08
	out	($93),a
.wait:
	in	a,($92)
	and	$80
	jr	z,.wait
	ld	a,$09
	out	($93),a
	pop	af
	out	($90),a
	ret

;
; ZN^wŃ[h
; i0x8000`0xFFFF̂݁AG[j
;
SEC_LOAD:
	ld	c,$00		; hCuԍ
	call	Disk_Load
	ret

;
; ZN^wŃZ[u
; iG[j
;
SEC_SAVE:
	ld	c,$00		; hCuԍ
	call	Disk_Save
	ret


;
; t@C[h
;
FILE_LOAD:
	push	bc
	push	de
	push	hl
	ld	(.sppt+1),sp		; SPޔ

	push	de
	ld	(FILE_SEARCH.fname+1),hl

	ld	hl,.end
	ld	(DISK_ERROR.ret+1),hl	; G[̖߂

	call	FILE_SEARCH
	pop	hl			; i[AhX

	call	Disk_Load
	jp	c,DISK_ERROR

	xor	a
.end:
.sppt:	ld	sp,$0000		; ޔSPǂݏo
	pop	hl
	pop	de
	pop	bc

	ret

;
; fBXNG[
;
DISK_ERROR:
	ld	a,$ff
	or	a
	scf
.ret:	jp	$0000


;
; track#1 sec#1`#3܂ł̃t@CXgt@CTāAԂ
; (.fname+1)Ft@C|C^
; RETURNF
; DFgbNԍ
; EFZN^ԍ
; BFZN^
; CFhCuԍi=0x00j
;
FILE_SEARCH:

	ld	de,$0101	; track#1Asec#1
.lp1:
	push	de
	ld	hl,DISKBUF
	ld	bc,$0100	; ZN^AhCuԍ

	call	Disk_Load
	jp	c,DISK_ERROR

	ld	hl,DISKBUF
.lp3:
.fname:	ld	de,$0000
	ld	b,9
.lp2:
	ld	a,(de)
	cp	(hl)
	jr	nz,.next
	inc	de
	inc	l
	djnz	.lp2
	jr	.find

.next:
	ld	a,l
	and	$f0
	add	a,$10
	ld	l,a
	jr	nz,.lp3

	pop	de
	inc	e
	ld	a,e
	cp	$4		; track#1Asec#3܂
	jr	c,.lp1
	jp	DISK_ERROR

.find:
	pop	de
	ld	a,l
	and	$f0
	add	a,$0c
	ld	l,a
	ld	d,(hl)		; gbNԍ
	inc	l
	ld	e,(hl)		; ZN^ԍ
	inc	l
	inc	l
	ld	b,(hl)		; ZN^
	ld	c,0

	ret

;
; t@CWJēǂݍ
; HLFt@C|C^
;
; 擪f[^
;   0` 51Ff[^0x00 1`52JԂ
;  52`103Ff[^0x55 1`52JԂ
; 104`155Ff[^0xaa 1`52JԂ
; 156`207Ff[^0xff 1`52JԂ
; 208`255Fʏf[^ 1`48
;
LOADEXPAND:
	ld	(.sppt+1),sp

	push	de

	ld	(FILE_SEARCH.fname+1),hl
	ld	hl,.end
	ld	(DISK_ERROR.ret+1),hl	; G[̖߂
	call	FILE_SEARCH

	push	hl
	call	INITDISKINFO
	pop	hl

	dec	l
	dec	l
	dec	l
	dec	l
	ld	d,(hl)
	dec	l
	ld	e,(hl)			; DEFt@C

	pop	hl			; i[AhX

.lp1:
	call	GET_EXBYTE
	ld	(hl),a
	inc	hl
	dec	de
	ld	a,d
	or	e
	jr	nz,.lp1

	xor	a

.end:
.sppt:	ld	sp,$0000
	ret

;
; drwpt@Cǂݏoݒ
; HLFt@C|C^
;
SETDRWFILE:
	ld	(FILE_SEARCH.fname+1),hl

	ld	hl,RETDRW
	ld	(DISK_ERROR.ret+1),hl	; G[̖߂
	call	FILE_SEARCH

	call	INITDISKINFO
	ret

; fBXNޔ
; DF擪gbNԍ
; EF擪ZN^ԍ
; BFZN^
; CFhCuԍ
;
DISKINFO:
	dw	$0000		; gbNԍ^ZN^ԍ
	dw	$0000		; ZN^^hCuԍ

INITDISKINFO:
	ld	(DISKINFO+0),de
	ld	b,1
	ld	(DISKINFO+2),bc
	exx
	ld	hl,DISKBUF
	ld	b,$00
	exx
	call	GET_SEC
	ret

;
; PZN^ǂݏo
;
; (DISKINFO+0)FZN^ԍ
; (DISKINFO+1)FgbNԍ
; (DISKINFO+2)FhCuԍ
; (DISKINFO+3)FZN^i=0x01j
;
GET_SEC:
	push	af
	push	bc
	push	de
	push	hl

	ld	de,(DISKINFO+0)
	ld	bc,(DISKINFO+2)
	ld	hl,DISKBUF
	push	de
	call	Disk_Load
	pop	de
	ld	a,2
	jp	c,DISK_ERROR

	inc	e
	ld	a,e
	cp	17
	jr	nz,.end
	ld	e,1
	inc	d
.end:
	ld	(DISKINFO+0),de

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret


;
; PoCgǂݏo
;
; HL'Fǂݏo|C^
;
; RETURN
; AFǂݏof[^
;
GET_BYTE:
	exx
	ld	a,(hl)
	inc	l
	exx
	ret	nz

	call	GET_SEC

	ret

;
; WJPoCgǂݏo
;
; HL'FfBXNobt@pǂݏo|C^
; B' Ff[^JE^
; C' Fo̓f[^iŒlj
; D' FŒltOiŒl0x00j
;
; RETURN
; AFWJf[^
;
GET_EXBYTE:
	exx
	ld	a,b
	or	a
	jr	z,.next

	dec	b		; JE^炷

	ld	a,d
	or	a
	jr	z,.nofix

		; Œlóij
	ld	a,c
	exx
	ret

		; ŒlȊOóij
.nofix:	exx
	call	GET_BYTE
	ret

		; f[^̐擪
.next:	exx
	call	GET_BYTE
	exx

	sub	52
	jr	nc,.next1
	ld	c,$00
	jr	.fixend
.next1:
	sub	52
	jr	nc,.next2
	ld	c,$55
	jr	.fixend
.next2:
	sub	52
	jr	nc,.next3
	ld	c,$aa
	jr	.fixend
.next3:
	sub	52
	jr	nc,.next4
	ld	c,$ff
	jr	.fixend
.next4:

		; ŒlȊOóiŏj

	ld	b,a
	ld	d,$00
	exx
	call	GET_BYTE
	ret

		; Œlóiŏj
.fixend:
	add	a,52
	ld	b,a
	ld	a,c
	ld	d,$ff
	exx
	ret

;
; vOI
;
	org	$86ff
	db	$ff



end
