;
; Np
;

	relaxed on

Disk_Routine	equ	$8000

Disk_Init	equ	Disk_Routine+0
Disk_Load	equ	Disk_Routine+3
Disk_Change1DD	equ	Disk_Routine+12

FILE_LOAD	equ	$854b


	org	$f900

;
; Track#0 Sector#1`
;
	db	"SYS"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de
	call	$4274		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c
	pop	af
	dec	a
	jr	nz,.loop
	ret

START:
	ld	sp,$b000

	xor	a		; hCuԍ-1
	ld	(ix+0),a
	ld	(ix+27),a	; G[JEg

	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$9000	; i[AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

	jp	MAIN



	org	$fa00
	phase	$9000

MAIN:

	call	CURCLS		; LN^ʐݒƃNA

	ld	c,$05		; CregFZN^ԍihCupǂݏo[`j

	ld	a,($fe74)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	bit	4,a
	jr	nz,.fd_in
	ld	c,$08		; CregFZN^ԍiOthCupǂݏo[`j

.fd_in:

;
; fBXNǂݏ[`[h
;
	ld	b,$00		; BregFgbNԍ
	ld	de,Disk_Routine	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

;
; 荞ݏȂǂ[h
;
	ld	bc,$000b	; BregFgbNԍACregFZN^ԍ
	ld	de,$8400	; i[擪AhX
	ld	a,$03		; ǂݍރZN^
	call	READ_NSEC

	di

;
; 0x0000`0xFFFF̃̓ǂݏRAMɂ
;

	ld	a,$dd
	out	($f0),a
	ld	a,$dd
	out	($f1),a
	ld	a,$55
	out	($f2),a

;
; fBXN[`̏
;

	ld	d,$00
	call	Disk_Init
	jp	c,DISKERR


;
; VXȅ
;
SYSINIT:

	im	2
	ld	a,$84
	ld	i,a		; 荞݃e[u0x8400`ɐݒ

	ld	hl,$0000	; VRAMNAiOtBbNj
.lp1:	ld	(hl),$00
	inc	hl
	ld	a,h
	cp	$40
	jr	nz,.lp1

	ld	a,$f1		; 320x200 / graphic / 40x20
	out	($c1),a

	ld	a,$f4
	out	($b0),a		; VRAMAhX=0x0000A^C}荞ON

	ld	a,$f0
	out	($c0),a		; CSS3-1=000

	ld	hl,SOUNDDATA

.lp2:
	ld	a,(hl)
	inc	hl
	inc	a
	jr	z,.lp3
	dec	a
	out	($a0),a
	ld	a,(hl)
	inc	hl
	out	($a1),a
	jr	.lp2

.lp3:
	ei

	call	DISPTITLE

	ld	de,$9400
	ld	hl,LOAD_NAME
	call	FILE_LOAD

	jp	$9400


LOAD_NAME:
	db	"loaderobj"

SOUNDDATA:
	db	 7,$bf		; ~LT
	db	 0,62		; `l`
	db	 1,0		; `l`
	db	 2,124		; `la
	db	 3,0		; `la
	db	 4,31		; `lb
	db	 5,0		; `lb
	db	 8,0		; `l`
	db	 9,0		; `la
	db	10,0		; `lb
	db	$ff


;
; ʃNAiLN^j
;
CURCLS:
	ld	a,$fd		; 160x200 / character / 40x20
	out	($c1),a
	ld	a,$f7
	out	($b0),a		; VRAMAhX=0x4000A^C}荞OFF

	ld	hl,$4000
.lp1:	ld	(hl),$0f
	inc	hl
	ld	a,h
	cp	$44
	jr	nz,.lp1
.lp2:	ld	(hl),$20
	inc	hl
	ld	a,h
	cp	$48
	jr	nz,.lp2


;
; \
;
PNT_MSG:
.msglp:
	ld	a,(de)
	inc	de
	or	a
	ret	z
	ld	(hl),a
	inc	hl
	jr	.msglp

;
; fBXNG[
;
DISKERR:
	ld	de,DISKNG_MSG
	ld	hl,$4400
	call	PNT_MSG
	jr	$

DISKNG_MSG:
	db	"Disk error",$00

;
; ԑ҂i 2ms ~ BCj
;
WAITTIME:
.lp1:	ld	a,$e2
.lp2:	dec	a
	nop
	jr	nz,.lp2

	dec	bc
	ld	a,b
	or	c
	jr	nz,.lp1
	ret


;
; ^Cg\
;
DISPTITLE:

	ld	a,$02			; CRTKILL
	out	($93),a
	ld	a,$f7			; 320x200 / character / 32x16
	out	($c1),a
	ld	a,$04			; 0x6000`0x7FFFCG-ROMɂ
	out	($93),a
	ld	hl,TITLEMSG1
	call	DISPMOJI
	ld	a,$05			; 0x6000`0x7FFFɖ߂
	out	($93),a
	ld	a,$f1			; 320x200 / graphic / 40x20
	out	($c1),a
	ld	a,$03			; CRTKILL
	out	($93),a

	ld	bc,100
	call	WAITTIME

	ld	a,$02			; CRTKILL
	out	($93),a
	ld	a,$f7			; 320x200 / character / 32x16
	out	($c1),a
	ld	a,$04			; 0x6000`0x7FFFCG-ROMɂ
	out	($93),a
	ld	hl,TITLEMSG2
	call	DISPMOJI
	ld	a,$05			; 0x6000`0x7FFFɖ߂
	out	($93),a
	ld	a,$f1			; 320x200 / graphic / 40x20
	out	($c1),a
	ld	a,$03			; CRTKILL
	out	($93),a

	ld	bc,500
	call	WAITTIME

	ld	hl,TITLEMSG3
	call	DISPMOJI

	ld	bc,200
	call	WAITTIME


	ret

;
; p\
;
; HLFp[^擪AhX
;
DISPMOJI:
	ld	d,(hl)		; XW
	inc	hl
	ld	e,(hl)		; YW
	inc	hl
	ld	c,(hl)		; F
	inc	hl
	xor	a		; NOP
	bit	0,c
	jr	z,.c0
	ld	a,$77		; ld  (hl),a
.c0:
	ld	(.p00),a
	ld	(.p01),a
	ld	(.p02),a

	xor	a		; NOP
	bit	1,c
	jr	z,.c1
	ld	a,$77		; ld  (hl),a
.c1:
	ld	(.p10),a
	ld	(.p11),a
	ld	(.p12),a

	ld	b,(hl)		; 
	inc	hl
	push	hl

	ld	c,d
	ld	d,0
	ld	h,d
	ld	l,e
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,de		; x5
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,hl		; x40

	ld	e,c
	add	hl,de		; VRAM擪

	pop	de		; f[^|C^

	ld	a,(de)
	inc	de
	or	a
	jr	nz,.kanji


.lp2:
	push	bc		; 
	push	hl		; VRAM

	ld	a,(de)		; f[^
	inc	de

	push	de		; f[^|C^

	ex	de,hl
	ld	l,a
	ld	h,0
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	add	hl,hl		; x16
	ex	de,hl

	ld	a,$60
	add	a,d
	ld	d,a

	ld	b,12
.lp1:
	ld	a,(de)
	inc	de
.p00:	ld	(hl),a		; v[#0
	set	5,h
.p10:	ld	(hl),a		; v[#1
	res	5,h

	ld	a,40
	add	a,l
	ld	l,a
	jr	nc,.noinc
	inc	h
.noinc:
	djnz	.lp1

	pop	de

	pop	hl
	inc	hl

	pop	bc
	djnz	.lp2

	ret


.kanji:
	ld	a,$d2
	out	($f0),a		; 0x0000-0x3FFF̓ǂݏoROM/ROM


.klp3:
	push	bc		; 

	ld	a,(de)		; AhX
	ld	c,a
	inc	de
	ld	a,(de)		; AhX
	inc	de

	push	de		; f[^|C^

	ld	e,c
	ld	d,a

	push	hl		; VRAM
	push	de		; AhX

	ld	a,$fd
	out	($c2),a		; ROM̍ǂݏo

	ld	b,16
.klp1:
	ld	a,(de)
	inc	de
.p01:	ld	(hl),a		; v[#0
	set	5,h
.p11:	ld	(hl),a		; v[#1
	res	5,h

	ld	a,40
	add	a,l
	ld	l,a
	jr	nc,.noinc2
	inc	h
.noinc2:
	djnz	.klp1

	pop	de		; AhX
	pop	hl		; VRAM
	inc	hl

	push	hl		; VRAM

	ld	a,$ff
	out	($c2),a		; ROM̉Eǂݏo

	ld	b,16
.klp2:
	ld	a,(de)
	inc	de
.p02:	ld	(hl),a		; v[#0
	set	5,h
.p12:	ld	(hl),a		; v[#1
	res	5,h

	ld	a,40
	add	a,l
	ld	l,a
	jr	nc,.noinc3
	inc	h
.noinc3:
	djnz	.klp2

	pop	hl		; VRAM
	inc	hl

	pop	de		; f[^|C^

	pop	bc		; 
	djnz	.klp3


	ld	a,$dd
	out	($f0),a		; 0x0000-0x3FFF̓ǂݏoRAMɖ߂

	ret

;
; \
;
TITLEMSG1:
	db	30/2			; XW(/8)
	db	84			; YW
	db	3-1			; F
	db	.ed+1-.st		; 
	db	0			; tO
.st:	db	'M'			; AhX
	db	'E'			; AhX
	db	'L'			; AhX
	db	'T'			; AhX
	db	' '			; AhX
	db	' '			; AhX
	db	'D'			; AhX
	db	'O'			; AhX
	db	'W'			; AhX
.ed:	db	'N'			; AhX

TITLEMSG2:
	db	18/2			; XW(/8)
	db	108			; YW
	db	3-1			; F
	db	.ed+1-.st		; 
	db	0			; tO
.st:	db	'P'			; AhX
	db	'r'			; AhX
	db	'e'			; AhX
	db	's'			; AhX
	db	'e'			; AhX
	db	'n'			; AhX
	db	't'			; AhX
	db	'e'			; AhX
	db	'd'			; AhX
	db	' '			; AhX
	db	'b'			; AhX
	db	'y'			; AhX
	db	' '			; AhX
	db	''-$20			; AhX
	db	''			; AhX
	db	''+$20			; AhX
	db	'-'			; AhX
	db	''+$20			; AhX
	db	''			; AhX
	db	'R'			; AhX
	db	'2'			; AhX
	db	'0'			; AhX
.ed:	db	'4'			; AhX



TITLEMSG3:
	db	34/2			; XW(/8)
	db	58			; YW
	db	4-1			; F
	db	(.ed+2-.st)/2		; 
	db	$ff			; tO
.st:	dw	16*(93-1)		; AhX""
	dw	16*(719-1)		; AhX""
.ed:	dw	16*(820-1)		; AhX""


	dephase

;
; vȌI
;

	org	$fcff
	db	$ff

end

